=== debian/changelog ===
bcftools (1.7-2) unstable; urgency=medium

  * Team upload.
  * Follow hint of Graham Inggs to skip single test that is new in this version
    Closes: #890704

 -- Andreas Tille <tille@debian.org>  Tue, 20 Feb 2018 16:32:47 +0100

bcftools (1.7-1) unstable; urgency=medium

  * Team upload
  * New upstream version
  * Standards-Version: 4.1.3
  * d/rules: drop useless option --parallel

 -- Andreas Tille <tille@debian.org>  Sat, 17 Feb 2018 15:00:09 +0100

bcftools (1.6-3) unstable; urgency=medium

  * Team upload
  * Upload to unstable

 -- Andreas Tille <tille@debian.org>  Thu, 14 Dec 2017 16:09:29 +0100

bcftools (1.6-2) experimental; urgency=medium

  * Team upload
  * Apply patch from upstream to reduce failing tests on different
    architectures.  Addresses bug #870060

 -- Andreas Tille <tille@debian.org>  Wed, 13 Dec 2017 15:57:03 +0100

bcftools (1.6-1) experimental; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.1.2

 -- Andreas Tille <tille@debian.org>  Mon, 11 Dec 2017 13:28:56 +0100

bcftools (1.5-4) unstable; urgency=medium

  * Team upload.
  * Add debian/clean to fix FTBFSx2
  * Update patches as they were applied upstream
  * Bump versioned Build-Depends on htslib to make sure we pick up
    versioned dependency on libhts2 (Closes: #881331)

 -- Graham Inggs <ginggs@debian.org>  Fri, 10 Nov 2017 12:41:15 +0000

bcftools (1.5-3) unstable; urgency=medium

  * Team upload.
  * Versioned Build-Depends on htslib to avoid FTBFS on armel, armhf and
    ppc64el

 -- Andreas Tille <tille@debian.org>  Wed, 08 Nov 2017 08:26:51 +0100

bcftools (1.5-2) unstable; urgency=low

  * Incorporate lost changes from 1.4.1-3 (Closes: #868958)
  * Update Standards-Version to 4.1.1
  * d/control: use build profiles to mark build-dependencies
    needed only for running tests

 -- Afif Elghraoui <afif@debian.org>  Thu, 12 Oct 2017 00:14:38 -0400

bcftools (1.5-1) unstable; urgency=medium

  * migrate to Unstable

 -- Afif Elghraoui <afif@debian.org>  Sun, 01 Oct 2017 12:39:31 -0400

bcftools (1.5-1~exp1) experimental; urgency=medium

  [ Afif Elghraoui ]
  * Update packaging for new build system

  [ Andreas Tille ]
  * New upstream version
  * Bump version in Build-Depends libhts-dev from 1.3.1 to 1.5
  * Standards-Version: 4.0.0 (no changes needed)

  [Steffen Moeller ]
  * [debian/upstream/metadata] Added registry references for
    OMICtools, RRID, bio.tools

 -- Afif Elghraoui <afif@debian.org>  Tue, 08 Aug 2017 12:35:44 -0400
