=== debian/rules ===
#!/usr/bin/make -f

#DH_VERBOSE = 1
#include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_installman:
	dh_installman --language=C

# clean target tries to include config.mk which does not exist inside clean source tree
clean: config.mk

config.mk:
	$(RM) $@ && touch $@

# m4 calls `make print-version` in configure.ac to set the version string.
# If `make` is not silent, this string includes logging messages about changing
# directories due to the way it is invoked, which breaks
# the C compiler test because it introduces a multiline #define statement with
# newlines not escaped.
override_dh_autoreconf: config.mk
	export MAKEFLAGS="-s"; dh_autoreconf

#override_dh_auto_configure:
override_dh_auto_configure:
	dh_auto_configure -- \
	--with-htslib=system \
	--enable-gsl \
	--with-cblas=gslcblas \
	--with-bcf-plugin-dir=/usr/lib/$(DEB_HOST_MULTIARCH)/bcftools
