=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: bcftools
-Section: science
-Priority: optional
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders:
 	Afif Elghraoui <afif@debian.org>
+Section: science
+Priority: optional
 Build-Depends:
-	debhelper (>= 10),
+	debhelper (>= 11~),
 	zlib1g-dev,
 	libbz2-dev,
 	liblzma-dev,
@@ -13,10 +13,10 @@
 	libgsl-dev,
 	tabix <!nocheck>,
 	libio-pty-perl <!nocheck>,
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
+Vcs-Browser: https://salsa.debian.org/med-team/bcftools
+Vcs-Git: https://salsa.debian.org/med-team/bcftools.git
 Homepage: http://samtools.github.io/bcftools/
-Vcs-Git: https://anonscm.debian.org/git/debian-med/bcftools.git
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bcftools.git
 
 Package: bcftools
 Architecture: any
