=== debian/changelog ===
bcftools (1.9-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.2.1
  * Fix Perl interpreter PATH

 -- Andreas Tille <tille@debian.org>  Tue, 04 Sep 2018 16:37:32 +0200

bcftools (1.8-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.4
  * debhelper 11

 -- Andreas Tille <tille@debian.org>  Fri, 20 Apr 2018 11:36:02 +0200
