=== debian/control ===
Source: bcftools
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Afif Elghraoui <afif@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11~),
               zlib1g-dev,
               libbz2-dev,
               liblzma-dev,
               libhts-dev (>= 1.5-3),
               libgsl-dev,
               tabix <!nocheck>,
               libio-pty-perl <!nocheck>
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/med-team/bcftools
Vcs-Git: https://salsa.debian.org/med-team/bcftools.git
Homepage: http://samtools.github.io/bcftools/

Package: bcftools
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${perl:Depends}
Suggests:
# These are needed for plot-vcfstats
          python,
          python-numpy,
          python-matplotlib,
          texlive-latex-recommended
Breaks: samtools (<< 1.0)
Replaces: samtools (<< 1.0)
Description: genomic variant calling and manipulation of VCF/BCF files
 BCFtools is a set of utilities that manipulate variant calls in the
 Variant Call Format (VCF) and its binary counterpart BCF. All commands work
 transparently with both VCFs and BCFs, both uncompressed and BGZF-compressed.
