=== debian/changelog ===
bcftools (1.10.2-4) unstable; urgency=medium

  * Fix suggested Python packages
    Closes: #965032

 -- Andreas Tille <tille@debian.org>  Tue, 14 Jul 2020 22:39:24 +0200

bcftools (1.10.2-3) unstable; urgency=medium

  * Team upload.
  * Depends on Perl demoted to Recommends
    Closes: #962834
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Wed, 17 Jun 2020 11:41:35 +0200

bcftools (1.10.2-2) unstable; urgency=medium

  * Fix build on i386 by using SSE2

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Thu, 02 Jan 2020 13:58:57 +0100

bcftools (1.10.2-1) unstable; urgency=medium

  * New upstream version
  * debhelper-compat 12

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 25 Dec 2019 17:58:32 +0100

bcftools (1.10-1) unstable; urgency=medium

  * New upstream release.
  * Restore i386 as libhts/tabix has restored it.
  * Add myself as an uploader

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 16 Dec 2019 16:17:57 +0100

bcftools (1.9-2) unstable; urgency=medium

  * Team upload.
  * Remove now-unneeded lintian-override
  * Remove i386 as libhts/tabix has dropped it
  * Temporarily disable failing plugins tests
  * Remove trailing whitespace in debian/copyright
  * Standards-Version: 4.3.0, no changes needed

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 06 Aug 2019 19:32:16 +0200
